<?php

//require_once '../../../config/inc.config.php';
require_once(PEAR_PATH."MDB2.php");
require_once('GestionBD_classe.php');
require_once(MODEL_PATH.'Article_classe.php');

class GestionBDArticle {
	private $gestionBD;


	function __construct()
	{
		$this->gestionBD = new GestionBD(DSN);
	}

	function getArticleById($id)
	{
		$req='select id, content, email from Article where id=:id';
		$result_types=array('integer','text','text');
		$types=array('integer');
		$data=array('id'=> $id);
		
		$resultSet = $this->gestionBD->queryPrepared($req,$types,$result_types,$data);
		$article = null;
		if ($resultSet->numRows()==1) {
			$row = $resultSet->fetchRow(MDB2_FETCHMODE_ASSOC);
			$article =  new Article($row['id'],$row['content'],$row['email']);
		}

		return $article;
	}

	function getLastArticle()
	{
		$req='select id, content, email from Article where id = (select max(id) from article)';
		$result_types=array('integer','text','text');
		$type=array();
		$data=array();
		
		$resultSet = $this->gestionBD->queryPrepared($req,$type, $result_types, $data);
		$article = null;
		if ($resultSet->numRows()==1) {
			$row = $resultSet->fetchRow(MDB2_FETCHMODE_ASSOC);
			$article =  new Article($row['id'],$row['content'],$row['email']);
		}

		return $article;
	}

	function getArticlesByEmail($email)
	{
		$req='select id, content, email from article where email=:email';
		$result_types=array('integer','text','text');
		$types=array('text');
		$data = array('email' => $email);
		
		$resultSet = $this->gestionBD->queryPrepared($req,$types,$result_types,$data);
		$articles = array();
		$rows = $resultSet->fetchAll(MDB2_FETCHMODE_ASSOC);
		foreach ($rows as $row)
		{
			$article =  new Article($row['id'],$row['content'],$row['email']);
			array_push($articles, $article);
		}
		return $articles;
	}

	function getAllArticles()
	{
		$req='select id, content, email from article';
		$result_types=array('integer','text','text');
		$types=array();
		$data = array();
		
		$resultSet = $this->gestionBD->queryPrepared($req,$types,$result_types,$data);
		$articles = array();
		$rows = $resultSet->fetchAll(MDB2_FETCHMODE_ASSOC);
		foreach ($rows as $row)
		{
			$article =  new Article($row['id'],$row['content'],$row['email']);
			array_push($articles, $article);
		}
		return $articles;
	}
	
	function delArticleById($id)
	{
		$req='delete from Article where id=:id';
		$types=array('integer');
		$data=array('id'=>$id);
		
		$res = $this ->gestionBD ->execPrepared($req, $types, $data);
		return $res;	
	}

	function createArticle($content, $email)
	{
		$id = $this->getLastArticle()->getId();

		$req='insert into Article (id, content, email) values (:id, :content, :email)';
		$types = array('integer','text','text');
		$data = array('id' => $id+1, 'content' => $content, 'email' => $email);

		$res = $this ->gestionBD ->execPrepared($req, $types, $data);
		return $res;



	}

	function updateArticle($id, $content, $email)
	{
		$req='update Article set id=:id, content=:content, email=:email where id=:id';
		$types = array('integer','text','text');
		$data = array('id' => $id, 'content' => $content, 'email'=> $email);	
		
		$res = $this ->gestionBD ->execPrepared($req, $types, $data);	
		return $res;
	}
}


?>