<?php

//require_once '../../../config/inc.config.php';
require_once(PEAR_PATH."MDB2.php");
require_once('GestionBD_classe.php');
require_once(MODEL_PATH.'User_classe.php');

class GestionBDUser {
	private $gestionBD;

	function __construct()
	{
		$this->gestionBD = new GestionBD(DSN);
	}

	function getUserByEmail($email)
	{
		$req= 'select email, password from User where email=:email';
		$types = array('text');
		$result_types = array('text', 'text');
		$data = array('email' => $email);
		
		$resultSet = $this->gestionBD->queryPrepared($req,$types, $result_types, $data);
		
		$user = null;
		if ($resultSet->numRows()==1) {
			$row = $resultSet->fetchRow(MDB2_FETCHMODE_ASSOC);
			$user =  new User($row['email'],$row['password']);
		}
		
		return $user;
	}

	function getAllUsers()
	{
		$req= 'select email, password from user';
		$types=array();
		$result_types = array('text', 'text');
		$data = array();
		
		$resultSet = $this->gestionBD->queryPrepared($req,$types, $result_types, $data);
		
		$users = array();
		$rows = $resultSet->fetchAll(MDB2_FETCHMODE_ASSOC);
		foreach ($rows as $row)
		{
			$user =  new User($row['email'],$row['password']);
			array_push($users, $user);
		}
		
		return $users;
	}

	function delUserByEmail($email)
	{
		$req= 'delete from User where email=:email';	
		$types = array('text');
		$data = array('email' => $email);
		$res = $this ->gestionBD ->execPrepared($req, $types, $data);	
		return $res;
	}

	function createUser($email, $password)
	{
		$req = 'insert into User (email,password) values (:email, :password)';
		$types = array('text','text');
		$data = array('email' => $email, 'password' => $password);	
		$res = $this ->gestionBD ->execPrepared($req, $types, $data);	
		return $res;
	}

	function updateUser($email, $password)
	{
		$req = 'update User set email=:email, password=:password where email=:email';	
		$types = array('text','text');
		$data = array('email' => $email, 'password' => $password);	
		$res = $this ->gestionBD ->execPrepared($req, $types, $data);	
		return $res;
	}
}


?>