<?php

/**
 * @author jub
 *Classe de gestion d'une base de donnes
 *Elle facilite l'utilisation des requtes prpares
 */
class GestionBD {

    /**
     * @var unknown_type la connexion  la base de donnes 
     */
    protected $mdb2 = null;

    /**
     * @param $dsn l'URL de connexion 
     */
    public function __construct($dsn) {
       
        $options = array(
            'debug' => 2,
            'result_buffering' => true,
        );
        $mdb2 = & MDB2::singleton($dsn,$options);
        
        if (MDB2::isError($mdb2)) {
            die($mdb2->getDebugInfo() & $mdb2->getMessage());
        }
        $this->mdb2 = $mdb2;
    }
    
    /**
     * Permet des requte ppares de type SELECT
     * @param $req la requete SQL avec ses paramtres
     * @param $types les types des paramtres
     * @param $result_types les types renvoys
     * @param $data le lien entre les paramtres et leurs valeures
     * @return unknown_type un resultset un tableau qui contient les enregistrements
     */
    public function queryPrepared($req,$types,$result_types,$data) {
       /*echo 'requete '.$req. '<br/>';
        echo 'types '; print_r($types); echo '<br/>';
        echo 'result_types'; print_r($result_types); echo'<br/>';
        echo 'data '; print_r($data); echo '<br/>';
        */
    	$statement = $this->mdb2->prepare($req,$types, $result_types);
    	
        $resultset = $statement->execute($data);
        //echo $this->mdb2->last_query;
        if (MDB2::isError($resultset)) {
        	die($resultset->getMessage());
        }
        return $resultset;            
    }    

    /**
     * Permet des requtes de type UPDATE, INSERT, DELETE, CREATE, DROP 
     * @param $req la requete SQL avec ses paramtres
     * @param $types les types des paramtres
     * @param $data le lien entre les paramtres et leurs valeures
     * @return unknown_type gnralement le nombre de lignes modifies
     */
    public function execPrepared($req,$types,$data) {
    	/*echo 'requete '.$req. '<br/>';
        echo 'types '; print_r($types); echo '<br/>';
        echo 'data '; print_r($data); echo '<br/>';
        */
        $statement = $this->mdb2->prepare($req,$types, MDB2_PREPARE_MANIP);
        $affectedRows = $statement->execute($data);
        //echo $this->mdb2->last_query;
        if (MDB2::isError($affectedRows)) {
            die($affectedRows->getMessage());
        }
        return $affectedRows;    
    }
    
    public function getMdb2()
    {
    	return $this->mdb2;
    }
}
?>